package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.course.bo.TeacherProjectAddBo;
import com.zhongzheng.modules.course.bo.TeacherProjectQueryBo;
import com.zhongzheng.modules.course.bo.TeacherProjectEditBo;
import com.zhongzheng.modules.course.domain.TeacherProject;
import com.zhongzheng.modules.course.mapper.TeacherProjectMapper;
import com.zhongzheng.modules.course.vo.TeacherProjectVo;
import com.zhongzheng.modules.course.service.ITeacherProjectService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 教师绑定项目Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-29
 */
@Service
public class TeacherProjectServiceImpl extends ServiceImpl<TeacherProjectMapper, TeacherProject> implements ITeacherProjectService {

    @Override
    public TeacherProjectVo queryById(Long id){
        TeacherProject db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, TeacherProjectVo.class);
    }

    @Override
    public List<TeacherProjectVo> queryList(TeacherProjectQueryBo bo) {
        LambdaQueryWrapper<TeacherProject> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getProjectId() != null, TeacherProject::getProjectId, bo.getProjectId());
        lqw.eq(bo.getTeacherId() != null, TeacherProject::getTeacherId, bo.getTeacherId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<TeacherProjectVo> entity2Vo(Collection<TeacherProject> collection) {
        List<TeacherProjectVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, TeacherProjectVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<TeacherProject> page = (Page<TeacherProject>)collection;
            Page<TeacherProjectVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(TeacherProjectAddBo bo) {
        TeacherProject add = BeanUtil.toBean(bo, TeacherProject.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(TeacherProjectEditBo bo) {
        TeacherProject update = BeanUtil.toBean(bo, TeacherProject.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(TeacherProject entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<TeacherProjectVo> queryTeacher(Long teacherId) {
        return baseMapper.queryTeacher(teacherId);
    }
}
